const C3 = self.C3;

const BEHAVIOR_INFO = {
    id: "piranha305_fsm",
    Acts: {
      "GoToState": {
            "forward": (inst) => inst._GoToState,
            
            "autoScriptInterface": true,
            },
"SetEnabled": {
            "forward": (inst) => inst._SetEnabled,
            
            "autoScriptInterface": true,
            }
    },
    Cnds: {
      "OnStateChange": {
            "forward": (inst) => inst._OnStateChange,
            
            "autoScriptInterface": true,
          },
"OnStateEnter": {
            "forward": (inst) => inst._OnStateEnter,
            
            "autoScriptInterface": true,
          },
"OnStateExit": {
            "forward": (inst) => inst._OnStateExit,
            
            "autoScriptInterface": true,
          },
"OnStateTransition": {
            "forward": (inst) => inst._OnStateTransition,
            
            "autoScriptInterface": true,
          },
"CurrentStateIs": {
            "forward": (inst) => inst._CurrentStateIs,
            
            "autoScriptInterface": true,
          },
"PreviousStateIs": {
            "forward": (inst) => inst._PreviousStateIs,
            
            "autoScriptInterface": true,
          },
"IsEnabled": {
            "forward": (inst) => inst._IsEnabled,
            
            "autoScriptInterface": true,
          },
"CurrentStateInList": {
            "forward": (inst) => inst._CurrentStateIn,
            
            "autoScriptInterface": true,
          },
"PreviousStateInList": {
            "forward": (inst) => inst._PreviousStateIn,
            
            "autoScriptInterface": true,
          },
"OnStateEnterInList": {
            "forward": (inst) => inst._OnStateEnterIn,
            
            "autoScriptInterface": true,
          },
"OnStateExitInList": {
            "forward": (inst) => inst._OnStateExitIn,
            
            "autoScriptInterface": true,
          }
    },
    Exps: {
      "CurrentState": {
            "forward": (inst) => inst._CurrentState,
            
            "autoScriptInterface": true,
          },
"PreviousState": {
            "forward": (inst) => inst._PreviousState,
            
            "autoScriptInterface": true,
          }
    },
  };

const camelCasedMap = new Map();

function camelCasify(str) {
  // If the string is already camelCased, return it
  if (camelCasedMap.has(str)) {
    return camelCasedMap.get(str);
  }
  // Replace any non-valid JavaScript identifier characters with spaces
  let cleanedStr = str.replace(/[^a-zA-Z0-9$_]/g, " ");

  // Split the string on spaces
  let words = cleanedStr.split(" ").filter(Boolean);

  // Capitalize the first letter of each word except for the first one
  for (let i = 1; i < words.length; i++) {
    words[i] = words[i].charAt(0).toUpperCase() + words[i].substring(1);
  }

  // Join the words back together
  let result = words.join("");

  // If the first character is a number, prepend an underscore
  if (!isNaN(parseInt(result.charAt(0)))) {
    result = "_" + result;
  }

  camelCasedMap.set(str, result);

  return result;
}

C3.Behaviors[BEHAVIOR_INFO.id] = class extends C3.SDKBehaviorBase {
  constructor(opts) {
    super(opts);
  }

  Release() {
    super.Release();
  }
};
const B_C = C3.Behaviors[BEHAVIOR_INFO.id];
B_C.Type = class extends C3.SDKBehaviorTypeBase {
  constructor(objectClass) {
    super(objectClass);
  }

  Release() {
    super.Release();
  }

  OnCreate() {}
};

//====== SCRIPT INTERFACE ======
const map = new WeakMap();

function getScriptInterface(parentClass, map) {
  return class extends parentClass {
    constructor() {
      super();
      map.set(this, parentClass._GetInitInst().GetSdkInstance());
    }
  };
}


const scriptInterface = getScriptInterface(self.IBehaviorInstance, map);

// extend script interface with plugin actions
Object.keys(BEHAVIOR_INFO.Acts).forEach((key) => {
  const ace = BEHAVIOR_INFO.Acts[key];
  if (!ace.autoScriptInterface) return;
  scriptInterface.prototype[camelCasify(key)] = function (...args) {
    const sdkInst = map.get(this);
    B_C.Acts[camelCasify(key)].call(sdkInst, ...args);
  };
});

const addonTriggers = [];

// extend script interface with plugin conditions
Object.keys(BEHAVIOR_INFO.Cnds).forEach((key) => {
  const ace = BEHAVIOR_INFO.Cnds[key];
  if (!ace.autoScriptInterface || ace.isStatic || ace.isLooping) return;
  if (ace.isTrigger) {
    scriptInterface.prototype[camelCasify(key)] = function (callback, ...args) {
      const callbackWrapper = () => {
        const sdkInst = map.get(this);
        if (B_C.Cnds[camelCasify(key)].call(sdkInst, ...args)) {
          callback();
        }
      };
      this.addEventListener(key, callbackWrapper, false);
      return () => this.removeEventListener(key, callbackWrapper, false);
    };
  } else {
    scriptInterface.prototype[camelCasify(key)] = function (...args) {
      const sdkInst = map.get(this);
      return B_C.Cnds[camelCasify(key)].call(sdkInst, ...args);
    };
  }
});

// extend script interface with plugin expressions
Object.keys(BEHAVIOR_INFO.Exps).forEach((key) => {
  const ace = BEHAVIOR_INFO.Exps[key];
  if (!ace.autoScriptInterface) return;
  scriptInterface.prototype[camelCasify(key)] = function (...args) {
    const sdkInst = map.get(this);
    return B_C.Exps[camelCasify(key)].call(sdkInst, ...args);
  };
});
//====== SCRIPT INTERFACE ======

//============ ACES ============
B_C.Acts = {};
B_C.Cnds = {};
B_C.Exps = {};
Object.keys(BEHAVIOR_INFO.Acts).forEach((key) => {
  const ace = BEHAVIOR_INFO.Acts[key];
  B_C.Acts[camelCasify(key)] = function (...args) {
    if (ace.forward) ace.forward(this).call(this, ...args);
    else if (ace.handler) ace.handler.call(this, ...args);
  };
});
Object.keys(BEHAVIOR_INFO.Cnds).forEach((key) => {
  const ace = BEHAVIOR_INFO.Cnds[key];
  B_C.Cnds[camelCasify(key)] = function (...args) {
    if (ace.forward) return ace.forward(this).call(this, ...args);
    if (ace.handler) return ace.handler.call(this, ...args);
  };
  if (ace.isTrigger && ace.autoScriptInterface) {
    addonTriggers.push({
      method: B_C.Cnds[camelCasify(key)],
      id: key,
    });
  }
});
Object.keys(BEHAVIOR_INFO.Exps).forEach((key) => {
  const ace = BEHAVIOR_INFO.Exps[key];
  B_C.Exps[camelCasify(key)] = function (...args) {
    if (ace.forward) return ace.forward(this).call(this, ...args);
    if (ace.handler) return ace.handler.call(this, ...args);
  };
});
//============ ACES ============

function getInstanceJs(parentClass, scriptInterface, addonTriggers, C3) {
  return class extends parentClass {
    constructor(inst, properties) {
      super(inst);

      this.previousState = "";
      this.currentState = "";
      this.initialState = "";
      this.enabled = false;

      if (properties) {
        this.enabled = properties[0];
        this.initialState = properties[1];
      }

      //check if initial state is empty string, if so set to default
      if(this.initialState == ""){
        this.initialState = "default";
      }

      this._TriggerInitialOnStateEnter();
    }

    _TriggerInitialOnStateEnter() {
      setTimeout(() => {
        this.previousState = "";
        this.currentState = this.initialState;
        this.Trigger(C3.Behaviors.piranha305_fsm.Cnds.OnStateChange);
        this.Trigger(C3.Behaviors.piranha305_fsm.Cnds.OnStateEnter);
        this.Trigger(C3.Behaviors.piranha305_fsm.Cnds.OnStateEnterInList);
      }, 0.0001);
    }

    _GoToState(state) {
      if(this.enabled && this.currentState != state){
        this.previousState = this.currentState;
        this.currentState = state;
        this.Trigger(C3.Behaviors.piranha305_fsm.Cnds.OnStateChange);
        this.Trigger(C3.Behaviors.piranha305_fsm.Cnds.OnStateExit);
        this.Trigger(C3.Behaviors.piranha305_fsm.Cnds.OnStateExitInList);
        this.Trigger(C3.Behaviors.piranha305_fsm.Cnds.OnStateEnter);
        this.Trigger(C3.Behaviors.piranha305_fsm.Cnds.OnStateEnterInList);
        this.Trigger(C3.Behaviors.piranha305_fsm.Cnds.OnStateTransition);
      }
    }

    _OnStateChange() {
      return this.enabled;
    }

    _OnStateEnter(state) {
      return this.enabled && this.currentState == state;
    }

    _OnStateExit(state) {
      return this.enabled && this.previousState == state;
    }

    _OnStateTransition(from, to){
      return this.enabled && this.previousState == from && this.currentState == to;
    }

    _CurrentStateIs(state) {
      return this.enabled && this.currentState == state;
    }

    _PreviousStateIs(state) {
      return this.enabled && this.previousState == state;
    }

    _CurrentStateIn(states) {
      states = states.split(",").map((x) => x.trim());
      return this.enabled && states.includes(this.currentState);
    }

    _PreviousStateIn(states) {
      states = states.split(",").map((x) => x.trim());
      return this.enabled && states.includes(this.previousState);
    }

    _OnStateEnterIn(states) {
      states = states.split(",").map((x) => x.trim());
      return this.enabled && states.includes(this.currentState);
    }

    _OnStateExitIn(states) {
      states = states.split(",").map((x) => x.trim());
      return this.enabled && states.includes(this.previousState);
    }

    _IsEnabled() {
      return this.enabled;
    }

    _SetEnabled(enabled) {
      this.enabled = enabled;
    }

    _CurrentState(){
      return this.currentState;
    }

    _PreviousState(){
      return this.previousState;
    }

    Release() {
      super.Release();
    }

    SaveToJson() {
      return {
        enabled: this.enabled,
        initialState: this.initialState,
        currentState: this.currentState,
        previousState: this.previousState
      };
    }

    LoadFromJson(o) {
      this.enabled = o.enabled;
      this.initialState = o.initialState;
      this.currentState = o.currentState;
      this.previousState = o.previousState;
    }

    GetDebuggerProperties() { 
      return [
        {
          title: "FSM",
          properties: [
            {
              name: "$current-state",
              value: this.currentState
            },
            {
              name: "$previous-state",
              value: this.previousState
            },
            {
              name: "$enabled",
              value: this.enabled
            }
          ]
        }
      ];
    }

    Trigger(method) {
      super.Trigger(method);
      const addonTrigger = addonTriggers.find((x) => x.method === method);
      if (addonTrigger) {
        this.GetScriptInterface().dispatchEvent(new C3.Event(addonTrigger.id));
      }
    }

    GetScriptInterfaceClass() {
      return scriptInterface;
    }
  };
}


B_C.Instance = getInstanceJs(
  C3.SDKBehaviorInstanceBase,
  scriptInterface,
  addonTriggers,
  C3
);
